/* http://www.giordanobenicchi.it/midi-tech/lowmidi.htm */

#include "stdafx.h"
#include <Windows.h>
#include <shlwapi.h>

HMIDIOUT      outHandle;

void CALLBACK midiCallback(HMIDIIN handle, UINT uMsg, DWORD dwInstance, DWORD dwParam1, DWORD dwParam2) {
    switch (uMsg) {
    case MIM_DATA:
//		printf("%i, %i, %i\n", LOBYTE(dwParam1), HIBYTE(dwParam1), LOBYTE(HIWORD(dwParam1)));
		// FX SELECT < / FX UNIT 1 151, 0x1B, 0x7F
		// FX SELECT > / FX UNIT 2 151, 0x1C, 0x7F
		// (o) X / P5              151, 92, 0x7F
		HWND handle;
		switch(LOBYTE(dwParam1)) {
			case 151: // note
				switch(LOBYTE(HIWORD(dwParam1))) {
					case 0x7F: // down
						printf("0x%02X, 0x%02X, 0x%02X\n", LOBYTE(dwParam1), HIBYTE(dwParam1), LOBYTE(HIWORD(dwParam1)));
						handle=FindWindow(NULL, "MilkDrop Console [VJ Mode]");
						if(handle) {
							switch(HIBYTE(dwParam1)) {
								case 0x1B:
									midiOutShortMsg(outHandle, 0x000F1B97);
									PostMessage(handle, WM_KEYDOWN, VK_BACK, 0);
									break;
								case 0x1C:
									midiOutShortMsg(outHandle, 0x000F1C97);
									PostMessage(handle, WM_KEYDOWN, VK_SPACE, 0);
									break;
								case 92:
									midiOutShortMsg(outHandle, 0x000F1B97);
									midiOutShortMsg(outHandle, 0x000F1C97);
									PostMessage(handle, WM_KEYDOWN, VK_SUBTRACT, 0);
									PostMessage(handle, WM_KEYUP, VK_SUBTRACT, 0);
									PostMessage(handle, WM_KEYDOWN, VK_SUBTRACT, 0);
									PostMessage(handle, WM_KEYUP, VK_SUBTRACT, 0);
									PostMessage(handle, WM_KEYDOWN, VK_SUBTRACT, 0);
									PostMessage(handle, WM_KEYUP, VK_SUBTRACT, 0);
									PostMessage(handle, WM_KEYDOWN, VK_SUBTRACT, 0);
									PostMessage(handle, WM_KEYUP, VK_SUBTRACT, 0);
									PostMessage(handle, WM_KEYDOWN, VK_SUBTRACT, 0);
									PostMessage(handle, WM_KEYUP, VK_SUBTRACT, 0);
									PostMessage(handle, WM_KEYDOWN, 0x48, 0);
									break;
							}
						} else {
							printf("'MilkDrop Console [VJ Mode]' window not found!\n");
						}
						break;
					case 0: // up
						printf("0x%02X, 0x%02X, 0x%02X\n", LOBYTE(dwParam1), HIBYTE(dwParam1), LOBYTE(HIWORD(dwParam1)));
						handle=FindWindow(NULL, "MilkDrop Console [VJ Mode]");
						if(handle) {
							switch(HIBYTE(dwParam1)) {
								case 0x1B:
									midiOutShortMsg(outHandle, 0x00001B97);
									PostMessage(handle, WM_KEYUP, VK_BACK, 0);
									break;
								case 0x1C:
									midiOutShortMsg(outHandle, 0x00001C97);
									PostMessage(handle, WM_KEYUP, VK_SPACE, 0);
									break;
								case 92:
									midiOutShortMsg(outHandle, 0x00001B97);
									midiOutShortMsg(outHandle, 0x00001C97);
									PostMessage(handle, WM_KEYUP, 0x48, 0);
									break;
							}
						} else {
							printf("'MilkDrop Console [VJ Mode]' window not found!\n");
						}
						break;
				}
				break;
		}
		break;
	}

}


int _tmain(int argc, _TCHAR* argv[])
{
	printf("Usage: %s in out [all]\n", argv[0]);
	printf("Written 2012, 2019 by Sven Killig <sven@killig.de>\n");
	printf("\n");

	unsigned long    iNumDevs, i;

	MIDIINCAPS     mic;
	HMIDIIN inHandle;

	/* Get the number of MIDI In devices in this computer */
	iNumDevs = midiInGetNumDevs();

	/* Go through all of those devices, displaying their names */
	for (i = 0; i < iNumDevs; i++)
	{
		/* Get info about the next device */
		if (!midiInGetDevCaps(i, &mic, sizeof(MIDIINCAPS)))
		{
			/* Display its Device ID and name */
			if (argc >= 3 && !_tcscmp(mic.szPname, argv[1])) {
				midiInOpen(&inHandle, i, (DWORD)midiCallback, 0, CALLBACK_FUNCTION);
				printf("* ");
			}
			printf("In Device ID #%u: %s\r\n", i, mic.szPname);
		}
	}

	printf("\n");

	MIDIOUTCAPS     moc;

	/* Get the number of MIDI Out devices in this computer */
	iNumDevs = midiOutGetNumDevs();

	/* Go through all of those devices, displaying their names */
	for (i = 0; i < iNumDevs; i++)
	{
		/* Get info about the next device */
		if (!midiOutGetDevCaps(i, &moc, sizeof(MIDIOUTCAPS)))
		{
			/* Display its Device ID and name */
			if (argc >= 3 && !_tcscmp(moc.szPname, argv[2])) {
				midiOutOpen(&outHandle, i, NULL, 0, CALLBACK_FUNCTION);
				printf("* ");
			}
			printf("Out Device ID #%u: %s\r\n", i, moc.szPname);
		}
	}

	printf("\n");

	if (argc < 3) {
		return -1;
	}

if (argc > 3) {
	if(atoi(argv[3])) midiOutShortMsg(outHandle, 0x007F00B7);
	else midiOutShortMsg(outHandle, 0x007000B7);
	return 0;
}

midiInStart(inHandle);

   MSG msg;
   while(GetMessage(&msg, NULL, 0, 0) > 0)
   {
     TranslateMessage(&msg);
     DispatchMessage(&msg);
   }

}
